unit schInventarioClient_Intf;

interface

uses
  Classes, DB, schBase_Intf, SysUtils, uROClasses, uDAInterfaces, uDADataTable, FmtBCD, uROXMLIntf;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_Inventario = '{D04FC2C5-D75A-471F-A38D-F2609EE8EDB5}';
  RID_DetalleReservas = '{BFC29192-74A7-46CC-BB5D-75D9B57EB4DA}';

  { Data table names }
  nme_Inventario = 'Inventario';
  nme_DetalleReservas = 'DetalleReservas';

  { Inventario fields }
  fld_InventarioID_ALMACEN = 'ID_ALMACEN';
  fld_InventarioID_ARTICULO = 'ID_ARTICULO';
  fld_InventarioALMACEN = 'ALMACEN';
  fld_InventarioID_EMPRESA = 'ID_EMPRESA';
  fld_InventarioREFERENCIA = 'REFERENCIA';
  fld_InventarioFAMILIA = 'FAMILIA';
  fld_InventarioDESCRIPCION = 'DESCRIPCION';
  fld_InventarioUNIDAD_MEDIDA = 'UNIDAD_MEDIDA';
  fld_InventarioREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';
  fld_InventarioPRECIO_NETO = 'PRECIO_NETO';
  fld_InventarioSTOCK = 'STOCK';
  fld_InventarioCOSTE_UNIDADES = 'COSTE_UNIDADES';
  fld_InventarioRESERVA = 'RESERVA';
  fld_InventarioPENDIENTE_RECEPCION = 'PENDIENTE_RECEPCION';
  fld_InventarioTIPO_ALMACEN = 'TIPO_ALMACEN';
  fld_InventarioUNIDADES_ALMACEN = 'UNIDADES_ALMACEN';
  fld_InventarioID = 'ID';
  fld_InventarioCANTIDAD = 'CANTIDAD';
  fld_InventarioFECHA_MOVIMIENTO = 'FECHA_MOVIMIENTO';
  fld_InventarioCAUSA = 'CAUSA';
  fld_InventarioTIPO = 'TIPO';
  fld_InventarioID_ALMACEN_RESERVA = 'ID_ALMACEN_RESERVA';

  { Inventario field indexes }
  idx_InventarioID_ALMACEN = 0;
  idx_InventarioID_ARTICULO = 1;
  idx_InventarioALMACEN = 2;
  idx_InventarioID_EMPRESA = 3;
  idx_InventarioREFERENCIA = 4;
  idx_InventarioFAMILIA = 5;
  idx_InventarioDESCRIPCION = 6;
  idx_InventarioUNIDAD_MEDIDA = 7;
  idx_InventarioREFERENCIA_PROVEEDOR = 8;
  idx_InventarioPRECIO_NETO = 9;
  idx_InventarioSTOCK = 10;
  idx_InventarioCOSTE_UNIDADES = 11;
  idx_InventarioRESERVA = 12;
  idx_InventarioPENDIENTE_RECEPCION = 13;
  idx_InventarioTIPO_ALMACEN = 14;
  idx_InventarioUNIDADES_ALMACEN = 15;
  idx_InventarioID = 16;
  idx_InventarioCANTIDAD = 17;
  idx_InventarioFECHA_MOVIMIENTO = 18;
  idx_InventarioCAUSA = 19;
  idx_InventarioTIPO = 20;
  idx_InventarioID_ALMACEN_RESERVA = 21;

  { DetalleReservas fields }
  fld_DetalleReservasID = 'ID';
  fld_DetalleReservasID_EMPRESA = 'ID_EMPRESA';
  fld_DetalleReservasID_ALMACEN = 'ID_ALMACEN';
  fld_DetalleReservasNOMBRE_ALMACEN = 'NOMBRE_ALMACEN';
  fld_DetalleReservasFECHA_RESERVA = 'FECHA_RESERVA';
  fld_DetalleReservasCAUSA_RESERVA = 'CAUSA_RESERVA';
  fld_DetalleReservasID_ARTICULO = 'ID_ARTICULO';
  fld_DetalleReservasREFERENCIA = 'REFERENCIA';
  fld_DetalleReservasDESCRIPCION = 'DESCRIPCION';
  fld_DetalleReservasFAMILIA = 'FAMILIA';
  fld_DetalleReservasUNIDAD_MEDIDA = 'UNIDAD_MEDIDA';
  fld_DetalleReservasFABRICANTE = 'FABRICANTE';
  fld_DetalleReservasREFERENCIA_FABR = 'REFERENCIA_FABR';
  fld_DetalleReservasCANTIDAD = 'CANTIDAD';
  fld_DetalleReservasID_ALMACEN_RESERVA = 'ID_ALMACEN_RESERVA';
  fld_DetalleReservasNOMBRE_ALMACEN_RESERVA = 'NOMBRE_ALMACEN_RESERVA';
  fld_DetalleReservasID_EMPRESA_ALMACEN_RESERVA = 'ID_EMPRESA_ALMACEN_RESERVA';

  { DetalleReservas field indexes }
  idx_DetalleReservasID = 0;
  idx_DetalleReservasID_EMPRESA = 1;
  idx_DetalleReservasID_ALMACEN = 2;
  idx_DetalleReservasNOMBRE_ALMACEN = 3;
  idx_DetalleReservasFECHA_RESERVA = 4;
  idx_DetalleReservasCAUSA_RESERVA = 5;
  idx_DetalleReservasID_ARTICULO = 6;
  idx_DetalleReservasREFERENCIA = 7;
  idx_DetalleReservasDESCRIPCION = 8;
  idx_DetalleReservasFAMILIA = 9;
  idx_DetalleReservasUNIDAD_MEDIDA = 10;
  idx_DetalleReservasFABRICANTE = 11;
  idx_DetalleReservasREFERENCIA_FABR = 12;
  idx_DetalleReservasCANTIDAD = 13;
  idx_DetalleReservasID_ALMACEN_RESERVA = 14;
  idx_DetalleReservasNOMBRE_ALMACEN_RESERVA = 15;
  idx_DetalleReservasID_EMPRESA_ALMACEN_RESERVA = 16;

type
  { IInventario }
  IInventario = interface(IDAStronglyTypedDataTable)
  ['{5FE325FA-C485-4522-8F90-B6B037D1764A}']
    { Property getters and setters }
    function GetID_ALMACENValue: Integer;
    procedure SetID_ALMACENValue(const aValue: Integer);
    function GetID_ALMACENIsNull: Boolean;
    procedure SetID_ALMACENIsNull(const aValue: Boolean);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetID_ARTICULOIsNull: Boolean;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean);
    function GetALMACENValue: String;
    procedure SetALMACENValue(const aValue: String);
    function GetALMACENIsNull: Boolean;
    procedure SetALMACENIsNull(const aValue: Boolean);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetFAMILIAValue: String;
    procedure SetFAMILIAValue(const aValue: String);
    function GetFAMILIAIsNull: Boolean;
    procedure SetFAMILIAIsNull(const aValue: Boolean);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetDESCRIPCIONIsNull: Boolean;
    procedure SetDESCRIPCIONIsNull(const aValue: Boolean);
    function GetUNIDAD_MEDIDAValue: String;
    procedure SetUNIDAD_MEDIDAValue(const aValue: String);
    function GetUNIDAD_MEDIDAIsNull: Boolean;
    procedure SetUNIDAD_MEDIDAIsNull(const aValue: Boolean);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORIsNull: Boolean;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);
    function GetPRECIO_NETOValue: Currency;
    procedure SetPRECIO_NETOValue(const aValue: Currency);
    function GetPRECIO_NETOIsNull: Boolean;
    procedure SetPRECIO_NETOIsNull(const aValue: Boolean);
    function GetSTOCKValue: Float;
    procedure SetSTOCKValue(const aValue: Float);
    function GetSTOCKIsNull: Boolean;
    procedure SetSTOCKIsNull(const aValue: Boolean);
    function GetCOSTE_UNIDADESValue: Currency;
    procedure SetCOSTE_UNIDADESValue(const aValue: Currency);
    function GetCOSTE_UNIDADESIsNull: Boolean;
    procedure SetCOSTE_UNIDADESIsNull(const aValue: Boolean);
    function GetRESERVAValue: Float;
    procedure SetRESERVAValue(const aValue: Float);
    function GetRESERVAIsNull: Boolean;
    procedure SetRESERVAIsNull(const aValue: Boolean);
    function GetPENDIENTE_RECEPCIONValue: Float;
    procedure SetPENDIENTE_RECEPCIONValue(const aValue: Float);
    function GetPENDIENTE_RECEPCIONIsNull: Boolean;
    procedure SetPENDIENTE_RECEPCIONIsNull(const aValue: Boolean);
    function GetTIPO_ALMACENValue: String;
    procedure SetTIPO_ALMACENValue(const aValue: String);
    function GetTIPO_ALMACENIsNull: Boolean;
    procedure SetTIPO_ALMACENIsNull(const aValue: Boolean);
    function GetUNIDADES_ALMACENValue: Float;
    procedure SetUNIDADES_ALMACENValue(const aValue: Float);
    function GetUNIDADES_ALMACENIsNull: Boolean;
    procedure SetUNIDADES_ALMACENIsNull(const aValue: Boolean);
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetCANTIDADValue: Float;
    procedure SetCANTIDADValue(const aValue: Float);
    function GetCANTIDADIsNull: Boolean;
    procedure SetCANTIDADIsNull(const aValue: Boolean);
    function GetFECHA_MOVIMIENTOValue: DateTime;
    procedure SetFECHA_MOVIMIENTOValue(const aValue: DateTime);
    function GetFECHA_MOVIMIENTOIsNull: Boolean;
    procedure SetFECHA_MOVIMIENTOIsNull(const aValue: Boolean);
    function GetCAUSAValue: String;
    procedure SetCAUSAValue(const aValue: String);
    function GetCAUSAIsNull: Boolean;
    procedure SetCAUSAIsNull(const aValue: Boolean);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);
    function GetTIPOIsNull: Boolean;
    procedure SetTIPOIsNull(const aValue: Boolean);
    function GetID_ALMACEN_RESERVAValue: Integer;
    procedure SetID_ALMACEN_RESERVAValue(const aValue: Integer);
    function GetID_ALMACEN_RESERVAIsNull: Boolean;
    procedure SetID_ALMACEN_RESERVAIsNull(const aValue: Boolean);


    { Properties }
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_ALMACENIsNull: Boolean read GetID_ALMACENIsNull write SetID_ALMACENIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property ALMACEN: String read GetALMACENValue write SetALMACENValue;
    property ALMACENIsNull: Boolean read GetALMACENIsNull write SetALMACENIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property FAMILIAIsNull: Boolean read GetFAMILIAIsNull write SetFAMILIAIsNull;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property DESCRIPCIONIsNull: Boolean read GetDESCRIPCIONIsNull write SetDESCRIPCIONIsNull;
    property UNIDAD_MEDIDA: String read GetUNIDAD_MEDIDAValue write SetUNIDAD_MEDIDAValue;
    property UNIDAD_MEDIDAIsNull: Boolean read GetUNIDAD_MEDIDAIsNull write SetUNIDAD_MEDIDAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;
    property PRECIO_NETO: Currency read GetPRECIO_NETOValue write SetPRECIO_NETOValue;
    property PRECIO_NETOIsNull: Boolean read GetPRECIO_NETOIsNull write SetPRECIO_NETOIsNull;
    property STOCK: Float read GetSTOCKValue write SetSTOCKValue;
    property STOCKIsNull: Boolean read GetSTOCKIsNull write SetSTOCKIsNull;
    property COSTE_UNIDADES: Currency read GetCOSTE_UNIDADESValue write SetCOSTE_UNIDADESValue;
    property COSTE_UNIDADESIsNull: Boolean read GetCOSTE_UNIDADESIsNull write SetCOSTE_UNIDADESIsNull;
    property RESERVA: Float read GetRESERVAValue write SetRESERVAValue;
    property RESERVAIsNull: Boolean read GetRESERVAIsNull write SetRESERVAIsNull;
    property PENDIENTE_RECEPCION: Float read GetPENDIENTE_RECEPCIONValue write SetPENDIENTE_RECEPCIONValue;
    property PENDIENTE_RECEPCIONIsNull: Boolean read GetPENDIENTE_RECEPCIONIsNull write SetPENDIENTE_RECEPCIONIsNull;
    property TIPO_ALMACEN: String read GetTIPO_ALMACENValue write SetTIPO_ALMACENValue;
    property TIPO_ALMACENIsNull: Boolean read GetTIPO_ALMACENIsNull write SetTIPO_ALMACENIsNull;
    property UNIDADES_ALMACEN: Float read GetUNIDADES_ALMACENValue write SetUNIDADES_ALMACENValue;
    property UNIDADES_ALMACENIsNull: Boolean read GetUNIDADES_ALMACENIsNull write SetUNIDADES_ALMACENIsNull;
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property CANTIDAD: Float read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property FECHA_MOVIMIENTO: DateTime read GetFECHA_MOVIMIENTOValue write SetFECHA_MOVIMIENTOValue;
    property FECHA_MOVIMIENTOIsNull: Boolean read GetFECHA_MOVIMIENTOIsNull write SetFECHA_MOVIMIENTOIsNull;
    property CAUSA: String read GetCAUSAValue write SetCAUSAValue;
    property CAUSAIsNull: Boolean read GetCAUSAIsNull write SetCAUSAIsNull;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull: Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property ID_ALMACEN_RESERVA: Integer read GetID_ALMACEN_RESERVAValue write SetID_ALMACEN_RESERVAValue;
    property ID_ALMACEN_RESERVAIsNull: Boolean read GetID_ALMACEN_RESERVAIsNull write SetID_ALMACEN_RESERVAIsNull;
  end;

  { TInventarioDataTableRules }
  TInventarioDataTableRules = class(TIntfObjectDADataTableRules, IInventario)
  private
  protected
    { Property getters and setters }
    function GetID_ALMACENValue: Integer; virtual;
    procedure SetID_ALMACENValue(const aValue: Integer); virtual;
    function GetID_ALMACENIsNull: Boolean; virtual;
    procedure SetID_ALMACENIsNull(const aValue: Boolean); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetID_ARTICULOIsNull: Boolean; virtual;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean); virtual;
    function GetALMACENValue: String; virtual;
    procedure SetALMACENValue(const aValue: String); virtual;
    function GetALMACENIsNull: Boolean; virtual;
    procedure SetALMACENIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetFAMILIAValue: String; virtual;
    procedure SetFAMILIAValue(const aValue: String); virtual;
    function GetFAMILIAIsNull: Boolean; virtual;
    procedure SetFAMILIAIsNull(const aValue: Boolean); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetDESCRIPCIONIsNull: Boolean; virtual;
    procedure SetDESCRIPCIONIsNull(const aValue: Boolean); virtual;
    function GetUNIDAD_MEDIDAValue: String; virtual;
    procedure SetUNIDAD_MEDIDAValue(const aValue: String); virtual;
    function GetUNIDAD_MEDIDAIsNull: Boolean; virtual;
    procedure SetUNIDAD_MEDIDAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORIsNull: Boolean; virtual;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetPRECIO_NETOValue: Currency; virtual;
    procedure SetPRECIO_NETOValue(const aValue: Currency); virtual;
    function GetPRECIO_NETOIsNull: Boolean; virtual;
    procedure SetPRECIO_NETOIsNull(const aValue: Boolean); virtual;
    function GetSTOCKValue: Float; virtual;
    procedure SetSTOCKValue(const aValue: Float); virtual;
    function GetSTOCKIsNull: Boolean; virtual;
    procedure SetSTOCKIsNull(const aValue: Boolean); virtual;
    function GetCOSTE_UNIDADESValue: Currency; virtual;
    procedure SetCOSTE_UNIDADESValue(const aValue: Currency); virtual;
    function GetCOSTE_UNIDADESIsNull: Boolean; virtual;
    procedure SetCOSTE_UNIDADESIsNull(const aValue: Boolean); virtual;
    function GetRESERVAValue: Float; virtual;
    procedure SetRESERVAValue(const aValue: Float); virtual;
    function GetRESERVAIsNull: Boolean; virtual;
    procedure SetRESERVAIsNull(const aValue: Boolean); virtual;
    function GetPENDIENTE_RECEPCIONValue: Float; virtual;
    procedure SetPENDIENTE_RECEPCIONValue(const aValue: Float); virtual;
    function GetPENDIENTE_RECEPCIONIsNull: Boolean; virtual;
    procedure SetPENDIENTE_RECEPCIONIsNull(const aValue: Boolean); virtual;
    function GetTIPO_ALMACENValue: String; virtual;
    procedure SetTIPO_ALMACENValue(const aValue: String); virtual;
    function GetTIPO_ALMACENIsNull: Boolean; virtual;
    procedure SetTIPO_ALMACENIsNull(const aValue: Boolean); virtual;
    function GetUNIDADES_ALMACENValue: Float; virtual;
    procedure SetUNIDADES_ALMACENValue(const aValue: Float); virtual;
    function GetUNIDADES_ALMACENIsNull: Boolean; virtual;
    procedure SetUNIDADES_ALMACENIsNull(const aValue: Boolean); virtual;
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetCANTIDADValue: Float; virtual;
    procedure SetCANTIDADValue(const aValue: Float); virtual;
    function GetCANTIDADIsNull: Boolean; virtual;
    procedure SetCANTIDADIsNull(const aValue: Boolean); virtual;
    function GetFECHA_MOVIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_MOVIMIENTOValue(const aValue: DateTime); virtual;
    function GetFECHA_MOVIMIENTOIsNull: Boolean; virtual;
    procedure SetFECHA_MOVIMIENTOIsNull(const aValue: Boolean); virtual;
    function GetCAUSAValue: String; virtual;
    procedure SetCAUSAValue(const aValue: String); virtual;
    function GetCAUSAIsNull: Boolean; virtual;
    procedure SetCAUSAIsNull(const aValue: Boolean); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetTIPOIsNull: Boolean; virtual;
    procedure SetTIPOIsNull(const aValue: Boolean); virtual;
    function GetID_ALMACEN_RESERVAValue: Integer; virtual;
    procedure SetID_ALMACEN_RESERVAValue(const aValue: Integer); virtual;
    function GetID_ALMACEN_RESERVAIsNull: Boolean; virtual;
    procedure SetID_ALMACEN_RESERVAIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_ALMACENIsNull: Boolean read GetID_ALMACENIsNull write SetID_ALMACENIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property ALMACEN: String read GetALMACENValue write SetALMACENValue;
    property ALMACENIsNull: Boolean read GetALMACENIsNull write SetALMACENIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property FAMILIAIsNull: Boolean read GetFAMILIAIsNull write SetFAMILIAIsNull;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property DESCRIPCIONIsNull: Boolean read GetDESCRIPCIONIsNull write SetDESCRIPCIONIsNull;
    property UNIDAD_MEDIDA: String read GetUNIDAD_MEDIDAValue write SetUNIDAD_MEDIDAValue;
    property UNIDAD_MEDIDAIsNull: Boolean read GetUNIDAD_MEDIDAIsNull write SetUNIDAD_MEDIDAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;
    property PRECIO_NETO: Currency read GetPRECIO_NETOValue write SetPRECIO_NETOValue;
    property PRECIO_NETOIsNull: Boolean read GetPRECIO_NETOIsNull write SetPRECIO_NETOIsNull;
    property STOCK: Float read GetSTOCKValue write SetSTOCKValue;
    property STOCKIsNull: Boolean read GetSTOCKIsNull write SetSTOCKIsNull;
    property COSTE_UNIDADES: Currency read GetCOSTE_UNIDADESValue write SetCOSTE_UNIDADESValue;
    property COSTE_UNIDADESIsNull: Boolean read GetCOSTE_UNIDADESIsNull write SetCOSTE_UNIDADESIsNull;
    property RESERVA: Float read GetRESERVAValue write SetRESERVAValue;
    property RESERVAIsNull: Boolean read GetRESERVAIsNull write SetRESERVAIsNull;
    property PENDIENTE_RECEPCION: Float read GetPENDIENTE_RECEPCIONValue write SetPENDIENTE_RECEPCIONValue;
    property PENDIENTE_RECEPCIONIsNull: Boolean read GetPENDIENTE_RECEPCIONIsNull write SetPENDIENTE_RECEPCIONIsNull;
    property TIPO_ALMACEN: String read GetTIPO_ALMACENValue write SetTIPO_ALMACENValue;
    property TIPO_ALMACENIsNull: Boolean read GetTIPO_ALMACENIsNull write SetTIPO_ALMACENIsNull;
    property UNIDADES_ALMACEN: Float read GetUNIDADES_ALMACENValue write SetUNIDADES_ALMACENValue;
    property UNIDADES_ALMACENIsNull: Boolean read GetUNIDADES_ALMACENIsNull write SetUNIDADES_ALMACENIsNull;
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property CANTIDAD: Float read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property FECHA_MOVIMIENTO: DateTime read GetFECHA_MOVIMIENTOValue write SetFECHA_MOVIMIENTOValue;
    property FECHA_MOVIMIENTOIsNull: Boolean read GetFECHA_MOVIMIENTOIsNull write SetFECHA_MOVIMIENTOIsNull;
    property CAUSA: String read GetCAUSAValue write SetCAUSAValue;
    property CAUSAIsNull: Boolean read GetCAUSAIsNull write SetCAUSAIsNull;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull: Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property ID_ALMACEN_RESERVA: Integer read GetID_ALMACEN_RESERVAValue write SetID_ALMACEN_RESERVAValue;
    property ID_ALMACEN_RESERVAIsNull: Boolean read GetID_ALMACEN_RESERVAIsNull write SetID_ALMACEN_RESERVAIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IDetalleReservas }
  IDetalleReservas = interface(IDAStronglyTypedDataTable)
  ['{7FE92649-C32F-47EB-9D9F-0CD43FECC0A1}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetID_ALMACENValue: Integer;
    procedure SetID_ALMACENValue(const aValue: Integer);
    function GetID_ALMACENIsNull: Boolean;
    procedure SetID_ALMACENIsNull(const aValue: Boolean);
    function GetNOMBRE_ALMACENValue: String;
    procedure SetNOMBRE_ALMACENValue(const aValue: String);
    function GetNOMBRE_ALMACENIsNull: Boolean;
    procedure SetNOMBRE_ALMACENIsNull(const aValue: Boolean);
    function GetFECHA_RESERVAValue: DateTime;
    procedure SetFECHA_RESERVAValue(const aValue: DateTime);
    function GetFECHA_RESERVAIsNull: Boolean;
    procedure SetFECHA_RESERVAIsNull(const aValue: Boolean);
    function GetCAUSA_RESERVAValue: String;
    procedure SetCAUSA_RESERVAValue(const aValue: String);
    function GetCAUSA_RESERVAIsNull: Boolean;
    procedure SetCAUSA_RESERVAIsNull(const aValue: Boolean);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetID_ARTICULOIsNull: Boolean;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetDESCRIPCIONIsNull: Boolean;
    procedure SetDESCRIPCIONIsNull(const aValue: Boolean);
    function GetFAMILIAValue: String;
    procedure SetFAMILIAValue(const aValue: String);
    function GetFAMILIAIsNull: Boolean;
    procedure SetFAMILIAIsNull(const aValue: Boolean);
    function GetUNIDAD_MEDIDAValue: String;
    procedure SetUNIDAD_MEDIDAValue(const aValue: String);
    function GetUNIDAD_MEDIDAIsNull: Boolean;
    procedure SetUNIDAD_MEDIDAIsNull(const aValue: Boolean);
    function GetFABRICANTEValue: String;
    procedure SetFABRICANTEValue(const aValue: String);
    function GetFABRICANTEIsNull: Boolean;
    procedure SetFABRICANTEIsNull(const aValue: Boolean);
    function GetREFERENCIA_FABRValue: String;
    procedure SetREFERENCIA_FABRValue(const aValue: String);
    function GetREFERENCIA_FABRIsNull: Boolean;
    procedure SetREFERENCIA_FABRIsNull(const aValue: Boolean);
    function GetCANTIDADValue: Currency;
    procedure SetCANTIDADValue(const aValue: Currency);
    function GetCANTIDADIsNull: Boolean;
    procedure SetCANTIDADIsNull(const aValue: Boolean);
    function GetID_ALMACEN_RESERVAValue: Integer;
    procedure SetID_ALMACEN_RESERVAValue(const aValue: Integer);
    function GetID_ALMACEN_RESERVAIsNull: Boolean;
    procedure SetID_ALMACEN_RESERVAIsNull(const aValue: Boolean);
    function GetNOMBRE_ALMACEN_RESERVAValue: String;
    procedure SetNOMBRE_ALMACEN_RESERVAValue(const aValue: String);
    function GetNOMBRE_ALMACEN_RESERVAIsNull: Boolean;
    procedure SetNOMBRE_ALMACEN_RESERVAIsNull(const aValue: Boolean);
    function GetID_EMPRESA_ALMACEN_RESERVAValue: Integer;
    procedure SetID_EMPRESA_ALMACEN_RESERVAValue(const aValue: Integer);
    function GetID_EMPRESA_ALMACEN_RESERVAIsNull: Boolean;
    procedure SetID_EMPRESA_ALMACEN_RESERVAIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_ALMACENIsNull: Boolean read GetID_ALMACENIsNull write SetID_ALMACENIsNull;
    property NOMBRE_ALMACEN: String read GetNOMBRE_ALMACENValue write SetNOMBRE_ALMACENValue;
    property NOMBRE_ALMACENIsNull: Boolean read GetNOMBRE_ALMACENIsNull write SetNOMBRE_ALMACENIsNull;
    property FECHA_RESERVA: DateTime read GetFECHA_RESERVAValue write SetFECHA_RESERVAValue;
    property FECHA_RESERVAIsNull: Boolean read GetFECHA_RESERVAIsNull write SetFECHA_RESERVAIsNull;
    property CAUSA_RESERVA: String read GetCAUSA_RESERVAValue write SetCAUSA_RESERVAValue;
    property CAUSA_RESERVAIsNull: Boolean read GetCAUSA_RESERVAIsNull write SetCAUSA_RESERVAIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property DESCRIPCIONIsNull: Boolean read GetDESCRIPCIONIsNull write SetDESCRIPCIONIsNull;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property FAMILIAIsNull: Boolean read GetFAMILIAIsNull write SetFAMILIAIsNull;
    property UNIDAD_MEDIDA: String read GetUNIDAD_MEDIDAValue write SetUNIDAD_MEDIDAValue;
    property UNIDAD_MEDIDAIsNull: Boolean read GetUNIDAD_MEDIDAIsNull write SetUNIDAD_MEDIDAIsNull;
    property FABRICANTE: String read GetFABRICANTEValue write SetFABRICANTEValue;
    property FABRICANTEIsNull: Boolean read GetFABRICANTEIsNull write SetFABRICANTEIsNull;
    property REFERENCIA_FABR: String read GetREFERENCIA_FABRValue write SetREFERENCIA_FABRValue;
    property REFERENCIA_FABRIsNull: Boolean read GetREFERENCIA_FABRIsNull write SetREFERENCIA_FABRIsNull;
    property CANTIDAD: Currency read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property ID_ALMACEN_RESERVA: Integer read GetID_ALMACEN_RESERVAValue write SetID_ALMACEN_RESERVAValue;
    property ID_ALMACEN_RESERVAIsNull: Boolean read GetID_ALMACEN_RESERVAIsNull write SetID_ALMACEN_RESERVAIsNull;
    property NOMBRE_ALMACEN_RESERVA: String read GetNOMBRE_ALMACEN_RESERVAValue write SetNOMBRE_ALMACEN_RESERVAValue;
    property NOMBRE_ALMACEN_RESERVAIsNull: Boolean read GetNOMBRE_ALMACEN_RESERVAIsNull write SetNOMBRE_ALMACEN_RESERVAIsNull;
    property ID_EMPRESA_ALMACEN_RESERVA: Integer read GetID_EMPRESA_ALMACEN_RESERVAValue write SetID_EMPRESA_ALMACEN_RESERVAValue;
    property ID_EMPRESA_ALMACEN_RESERVAIsNull: Boolean read GetID_EMPRESA_ALMACEN_RESERVAIsNull write SetID_EMPRESA_ALMACEN_RESERVAIsNull;
  end;

  { TDetalleReservasDataTableRules }
  TDetalleReservasDataTableRules = class(TIntfObjectDADataTableRules, IDetalleReservas)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetID_ALMACENValue: Integer; virtual;
    procedure SetID_ALMACENValue(const aValue: Integer); virtual;
    function GetID_ALMACENIsNull: Boolean; virtual;
    procedure SetID_ALMACENIsNull(const aValue: Boolean); virtual;
    function GetNOMBRE_ALMACENValue: String; virtual;
    procedure SetNOMBRE_ALMACENValue(const aValue: String); virtual;
    function GetNOMBRE_ALMACENIsNull: Boolean; virtual;
    procedure SetNOMBRE_ALMACENIsNull(const aValue: Boolean); virtual;
    function GetFECHA_RESERVAValue: DateTime; virtual;
    procedure SetFECHA_RESERVAValue(const aValue: DateTime); virtual;
    function GetFECHA_RESERVAIsNull: Boolean; virtual;
    procedure SetFECHA_RESERVAIsNull(const aValue: Boolean); virtual;
    function GetCAUSA_RESERVAValue: String; virtual;
    procedure SetCAUSA_RESERVAValue(const aValue: String); virtual;
    function GetCAUSA_RESERVAIsNull: Boolean; virtual;
    procedure SetCAUSA_RESERVAIsNull(const aValue: Boolean); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetID_ARTICULOIsNull: Boolean; virtual;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetDESCRIPCIONIsNull: Boolean; virtual;
    procedure SetDESCRIPCIONIsNull(const aValue: Boolean); virtual;
    function GetFAMILIAValue: String; virtual;
    procedure SetFAMILIAValue(const aValue: String); virtual;
    function GetFAMILIAIsNull: Boolean; virtual;
    procedure SetFAMILIAIsNull(const aValue: Boolean); virtual;
    function GetUNIDAD_MEDIDAValue: String; virtual;
    procedure SetUNIDAD_MEDIDAValue(const aValue: String); virtual;
    function GetUNIDAD_MEDIDAIsNull: Boolean; virtual;
    procedure SetUNIDAD_MEDIDAIsNull(const aValue: Boolean); virtual;
    function GetFABRICANTEValue: String; virtual;
    procedure SetFABRICANTEValue(const aValue: String); virtual;
    function GetFABRICANTEIsNull: Boolean; virtual;
    procedure SetFABRICANTEIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_FABRValue: String; virtual;
    procedure SetREFERENCIA_FABRValue(const aValue: String); virtual;
    function GetREFERENCIA_FABRIsNull: Boolean; virtual;
    procedure SetREFERENCIA_FABRIsNull(const aValue: Boolean); virtual;
    function GetCANTIDADValue: Currency; virtual;
    procedure SetCANTIDADValue(const aValue: Currency); virtual;
    function GetCANTIDADIsNull: Boolean; virtual;
    procedure SetCANTIDADIsNull(const aValue: Boolean); virtual;
    function GetID_ALMACEN_RESERVAValue: Integer; virtual;
    procedure SetID_ALMACEN_RESERVAValue(const aValue: Integer); virtual;
    function GetID_ALMACEN_RESERVAIsNull: Boolean; virtual;
    procedure SetID_ALMACEN_RESERVAIsNull(const aValue: Boolean); virtual;
    function GetNOMBRE_ALMACEN_RESERVAValue: String; virtual;
    procedure SetNOMBRE_ALMACEN_RESERVAValue(const aValue: String); virtual;
    function GetNOMBRE_ALMACEN_RESERVAIsNull: Boolean; virtual;
    procedure SetNOMBRE_ALMACEN_RESERVAIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESA_ALMACEN_RESERVAValue: Integer; virtual;
    procedure SetID_EMPRESA_ALMACEN_RESERVAValue(const aValue: Integer); virtual;
    function GetID_EMPRESA_ALMACEN_RESERVAIsNull: Boolean; virtual;
    procedure SetID_EMPRESA_ALMACEN_RESERVAIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_ALMACENIsNull: Boolean read GetID_ALMACENIsNull write SetID_ALMACENIsNull;
    property NOMBRE_ALMACEN: String read GetNOMBRE_ALMACENValue write SetNOMBRE_ALMACENValue;
    property NOMBRE_ALMACENIsNull: Boolean read GetNOMBRE_ALMACENIsNull write SetNOMBRE_ALMACENIsNull;
    property FECHA_RESERVA: DateTime read GetFECHA_RESERVAValue write SetFECHA_RESERVAValue;
    property FECHA_RESERVAIsNull: Boolean read GetFECHA_RESERVAIsNull write SetFECHA_RESERVAIsNull;
    property CAUSA_RESERVA: String read GetCAUSA_RESERVAValue write SetCAUSA_RESERVAValue;
    property CAUSA_RESERVAIsNull: Boolean read GetCAUSA_RESERVAIsNull write SetCAUSA_RESERVAIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property DESCRIPCIONIsNull: Boolean read GetDESCRIPCIONIsNull write SetDESCRIPCIONIsNull;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property FAMILIAIsNull: Boolean read GetFAMILIAIsNull write SetFAMILIAIsNull;
    property UNIDAD_MEDIDA: String read GetUNIDAD_MEDIDAValue write SetUNIDAD_MEDIDAValue;
    property UNIDAD_MEDIDAIsNull: Boolean read GetUNIDAD_MEDIDAIsNull write SetUNIDAD_MEDIDAIsNull;
    property FABRICANTE: String read GetFABRICANTEValue write SetFABRICANTEValue;
    property FABRICANTEIsNull: Boolean read GetFABRICANTEIsNull write SetFABRICANTEIsNull;
    property REFERENCIA_FABR: String read GetREFERENCIA_FABRValue write SetREFERENCIA_FABRValue;
    property REFERENCIA_FABRIsNull: Boolean read GetREFERENCIA_FABRIsNull write SetREFERENCIA_FABRIsNull;
    property CANTIDAD: Currency read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property ID_ALMACEN_RESERVA: Integer read GetID_ALMACEN_RESERVAValue write SetID_ALMACEN_RESERVAValue;
    property ID_ALMACEN_RESERVAIsNull: Boolean read GetID_ALMACEN_RESERVAIsNull write SetID_ALMACEN_RESERVAIsNull;
    property NOMBRE_ALMACEN_RESERVA: String read GetNOMBRE_ALMACEN_RESERVAValue write SetNOMBRE_ALMACEN_RESERVAValue;
    property NOMBRE_ALMACEN_RESERVAIsNull: Boolean read GetNOMBRE_ALMACEN_RESERVAIsNull write SetNOMBRE_ALMACEN_RESERVAIsNull;
    property ID_EMPRESA_ALMACEN_RESERVA: Integer read GetID_EMPRESA_ALMACEN_RESERVAValue write SetID_EMPRESA_ALMACEN_RESERVAValue;
    property ID_EMPRESA_ALMACEN_RESERVAIsNull: Boolean read GetID_EMPRESA_ALMACEN_RESERVAIsNull write SetID_EMPRESA_ALMACEN_RESERVAIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants, uROBinaryHelpers;

{ TInventarioDataTableRules }
constructor TInventarioDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TInventarioDataTableRules.Destroy;
begin
  inherited;
end;

function TInventarioDataTableRules.GetID_ALMACENValue: Integer;
begin
  result := DataTable.Fields[idx_InventarioID_ALMACEN].AsInteger;
end;

procedure TInventarioDataTableRules.SetID_ALMACENValue(const aValue: Integer);
begin
  DataTable.Fields[idx_InventarioID_ALMACEN].AsInteger := aValue;
end;

function TInventarioDataTableRules.GetID_ALMACENIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioID_ALMACEN].IsNull;
end;

procedure TInventarioDataTableRules.SetID_ALMACENIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioID_ALMACEN].AsVariant := Null;
end;

function TInventarioDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_InventarioID_ARTICULO].AsInteger;
end;

procedure TInventarioDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_InventarioID_ARTICULO].AsInteger := aValue;
end;

function TInventarioDataTableRules.GetID_ARTICULOIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioID_ARTICULO].IsNull;
end;

procedure TInventarioDataTableRules.SetID_ARTICULOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioID_ARTICULO].AsVariant := Null;
end;

function TInventarioDataTableRules.GetALMACENValue: String;
begin
  result := DataTable.Fields[idx_InventarioALMACEN].AsString;
end;

procedure TInventarioDataTableRules.SetALMACENValue(const aValue: String);
begin
  DataTable.Fields[idx_InventarioALMACEN].AsString := aValue;
end;

function TInventarioDataTableRules.GetALMACENIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioALMACEN].IsNull;
end;

procedure TInventarioDataTableRules.SetALMACENIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioALMACEN].AsVariant := Null;
end;

function TInventarioDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_InventarioID_EMPRESA].AsInteger;
end;

procedure TInventarioDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_InventarioID_EMPRESA].AsInteger := aValue;
end;

function TInventarioDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioID_EMPRESA].IsNull;
end;

procedure TInventarioDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioID_EMPRESA].AsVariant := Null;
end;

function TInventarioDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_InventarioREFERENCIA].AsString;
end;

procedure TInventarioDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_InventarioREFERENCIA].AsString := aValue;
end;

function TInventarioDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioREFERENCIA].IsNull;
end;

procedure TInventarioDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioREFERENCIA].AsVariant := Null;
end;

function TInventarioDataTableRules.GetFAMILIAValue: String;
begin
  result := DataTable.Fields[idx_InventarioFAMILIA].AsString;
end;

procedure TInventarioDataTableRules.SetFAMILIAValue(const aValue: String);
begin
  DataTable.Fields[idx_InventarioFAMILIA].AsString := aValue;
end;

function TInventarioDataTableRules.GetFAMILIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioFAMILIA].IsNull;
end;

procedure TInventarioDataTableRules.SetFAMILIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioFAMILIA].AsVariant := Null;
end;

function TInventarioDataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_InventarioDESCRIPCION].AsString;
end;

procedure TInventarioDataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_InventarioDESCRIPCION].AsString := aValue;
end;

function TInventarioDataTableRules.GetDESCRIPCIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioDESCRIPCION].IsNull;
end;

procedure TInventarioDataTableRules.SetDESCRIPCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioDESCRIPCION].AsVariant := Null;
end;

function TInventarioDataTableRules.GetUNIDAD_MEDIDAValue: String;
begin
  result := DataTable.Fields[idx_InventarioUNIDAD_MEDIDA].AsString;
end;

procedure TInventarioDataTableRules.SetUNIDAD_MEDIDAValue(const aValue: String);
begin
  DataTable.Fields[idx_InventarioUNIDAD_MEDIDA].AsString := aValue;
end;

function TInventarioDataTableRules.GetUNIDAD_MEDIDAIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioUNIDAD_MEDIDA].IsNull;
end;

procedure TInventarioDataTableRules.SetUNIDAD_MEDIDAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioUNIDAD_MEDIDA].AsVariant := Null;
end;

function TInventarioDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_InventarioREFERENCIA_PROVEEDOR].AsString;
end;

procedure TInventarioDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_InventarioREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TInventarioDataTableRules.GetREFERENCIA_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioREFERENCIA_PROVEEDOR].IsNull;
end;

procedure TInventarioDataTableRules.SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioREFERENCIA_PROVEEDOR].AsVariant := Null;
end;

function TInventarioDataTableRules.GetPRECIO_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_InventarioPRECIO_NETO].AsCurrency;
end;

procedure TInventarioDataTableRules.SetPRECIO_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_InventarioPRECIO_NETO].AsCurrency := aValue;
end;

function TInventarioDataTableRules.GetPRECIO_NETOIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioPRECIO_NETO].IsNull;
end;

procedure TInventarioDataTableRules.SetPRECIO_NETOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioPRECIO_NETO].AsVariant := Null;
end;

function TInventarioDataTableRules.GetSTOCKValue: Float;
begin
  result := DataTable.Fields[idx_InventarioSTOCK].AsFloat;
end;

procedure TInventarioDataTableRules.SetSTOCKValue(const aValue: Float);
begin
  DataTable.Fields[idx_InventarioSTOCK].AsFloat := aValue;
end;

function TInventarioDataTableRules.GetSTOCKIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioSTOCK].IsNull;
end;

procedure TInventarioDataTableRules.SetSTOCKIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioSTOCK].AsVariant := Null;
end;

function TInventarioDataTableRules.GetCOSTE_UNIDADESValue: Currency;
begin
  result := DataTable.Fields[idx_InventarioCOSTE_UNIDADES].AsCurrency;
end;

procedure TInventarioDataTableRules.SetCOSTE_UNIDADESValue(const aValue: Currency);
begin
  DataTable.Fields[idx_InventarioCOSTE_UNIDADES].AsCurrency := aValue;
end;

function TInventarioDataTableRules.GetCOSTE_UNIDADESIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioCOSTE_UNIDADES].IsNull;
end;

procedure TInventarioDataTableRules.SetCOSTE_UNIDADESIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioCOSTE_UNIDADES].AsVariant := Null;
end;

function TInventarioDataTableRules.GetRESERVAValue: Float;
begin
  result := DataTable.Fields[idx_InventarioRESERVA].AsFloat;
end;

procedure TInventarioDataTableRules.SetRESERVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_InventarioRESERVA].AsFloat := aValue;
end;

function TInventarioDataTableRules.GetRESERVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioRESERVA].IsNull;
end;

procedure TInventarioDataTableRules.SetRESERVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioRESERVA].AsVariant := Null;
end;

function TInventarioDataTableRules.GetPENDIENTE_RECEPCIONValue: Float;
begin
  result := DataTable.Fields[idx_InventarioPENDIENTE_RECEPCION].AsFloat;
end;

procedure TInventarioDataTableRules.SetPENDIENTE_RECEPCIONValue(const aValue: Float);
begin
  DataTable.Fields[idx_InventarioPENDIENTE_RECEPCION].AsFloat := aValue;
end;

function TInventarioDataTableRules.GetPENDIENTE_RECEPCIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioPENDIENTE_RECEPCION].IsNull;
end;

procedure TInventarioDataTableRules.SetPENDIENTE_RECEPCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioPENDIENTE_RECEPCION].AsVariant := Null;
end;

function TInventarioDataTableRules.GetTIPO_ALMACENValue: String;
begin
  result := DataTable.Fields[idx_InventarioTIPO_ALMACEN].AsString;
end;

procedure TInventarioDataTableRules.SetTIPO_ALMACENValue(const aValue: String);
begin
  DataTable.Fields[idx_InventarioTIPO_ALMACEN].AsString := aValue;
end;

function TInventarioDataTableRules.GetTIPO_ALMACENIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioTIPO_ALMACEN].IsNull;
end;

procedure TInventarioDataTableRules.SetTIPO_ALMACENIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioTIPO_ALMACEN].AsVariant := Null;
end;

function TInventarioDataTableRules.GetUNIDADES_ALMACENValue: Float;
begin
  result := DataTable.Fields[idx_InventarioUNIDADES_ALMACEN].AsFloat;
end;

procedure TInventarioDataTableRules.SetUNIDADES_ALMACENValue(const aValue: Float);
begin
  DataTable.Fields[idx_InventarioUNIDADES_ALMACEN].AsFloat := aValue;
end;

function TInventarioDataTableRules.GetUNIDADES_ALMACENIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioUNIDADES_ALMACEN].IsNull;
end;

procedure TInventarioDataTableRules.SetUNIDADES_ALMACENIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioUNIDADES_ALMACEN].AsVariant := Null;
end;

function TInventarioDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_InventarioID].AsInteger;
end;

procedure TInventarioDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_InventarioID].AsInteger := aValue;
end;

function TInventarioDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioID].IsNull;
end;

procedure TInventarioDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioID].AsVariant := Null;
end;

function TInventarioDataTableRules.GetCANTIDADValue: Float;
begin
  result := DataTable.Fields[idx_InventarioCANTIDAD].AsFloat;
end;

procedure TInventarioDataTableRules.SetCANTIDADValue(const aValue: Float);
begin
  DataTable.Fields[idx_InventarioCANTIDAD].AsFloat := aValue;
end;

function TInventarioDataTableRules.GetCANTIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioCANTIDAD].IsNull;
end;

procedure TInventarioDataTableRules.SetCANTIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioCANTIDAD].AsVariant := Null;
end;

function TInventarioDataTableRules.GetFECHA_MOVIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_InventarioFECHA_MOVIMIENTO].AsDateTime;
end;

procedure TInventarioDataTableRules.SetFECHA_MOVIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_InventarioFECHA_MOVIMIENTO].AsDateTime := aValue;
end;

function TInventarioDataTableRules.GetFECHA_MOVIMIENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioFECHA_MOVIMIENTO].IsNull;
end;

procedure TInventarioDataTableRules.SetFECHA_MOVIMIENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioFECHA_MOVIMIENTO].AsVariant := Null;
end;

function TInventarioDataTableRules.GetCAUSAValue: String;
begin
  result := DataTable.Fields[idx_InventarioCAUSA].AsString;
end;

procedure TInventarioDataTableRules.SetCAUSAValue(const aValue: String);
begin
  DataTable.Fields[idx_InventarioCAUSA].AsString := aValue;
end;

function TInventarioDataTableRules.GetCAUSAIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioCAUSA].IsNull;
end;

procedure TInventarioDataTableRules.SetCAUSAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioCAUSA].AsVariant := Null;
end;

function TInventarioDataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_InventarioTIPO].AsString;
end;

procedure TInventarioDataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_InventarioTIPO].AsString := aValue;
end;

function TInventarioDataTableRules.GetTIPOIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioTIPO].IsNull;
end;

procedure TInventarioDataTableRules.SetTIPOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioTIPO].AsVariant := Null;
end;

function TInventarioDataTableRules.GetID_ALMACEN_RESERVAValue: Integer;
begin
  result := DataTable.Fields[idx_InventarioID_ALMACEN_RESERVA].AsInteger;
end;

procedure TInventarioDataTableRules.SetID_ALMACEN_RESERVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_InventarioID_ALMACEN_RESERVA].AsInteger := aValue;
end;

function TInventarioDataTableRules.GetID_ALMACEN_RESERVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_InventarioID_ALMACEN_RESERVA].IsNull;
end;

procedure TInventarioDataTableRules.SetID_ALMACEN_RESERVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_InventarioID_ALMACEN_RESERVA].AsVariant := Null;
end;


{ TDetalleReservasDataTableRules }
constructor TDetalleReservasDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TDetalleReservasDataTableRules.Destroy;
begin
  inherited;
end;

function TDetalleReservasDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_DetalleReservasID].AsInteger;
end;

procedure TDetalleReservasDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DetalleReservasID].AsInteger := aValue;
end;

function TDetalleReservasDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasID].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasID].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_DetalleReservasID_EMPRESA].AsInteger;
end;

procedure TDetalleReservasDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DetalleReservasID_EMPRESA].AsInteger := aValue;
end;

function TDetalleReservasDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasID_EMPRESA].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasID_EMPRESA].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetID_ALMACENValue: Integer;
begin
  result := DataTable.Fields[idx_DetalleReservasID_ALMACEN].AsInteger;
end;

procedure TDetalleReservasDataTableRules.SetID_ALMACENValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DetalleReservasID_ALMACEN].AsInteger := aValue;
end;

function TDetalleReservasDataTableRules.GetID_ALMACENIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasID_ALMACEN].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetID_ALMACENIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasID_ALMACEN].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetNOMBRE_ALMACENValue: String;
begin
  result := DataTable.Fields[idx_DetalleReservasNOMBRE_ALMACEN].AsString;
end;

procedure TDetalleReservasDataTableRules.SetNOMBRE_ALMACENValue(const aValue: String);
begin
  DataTable.Fields[idx_DetalleReservasNOMBRE_ALMACEN].AsString := aValue;
end;

function TDetalleReservasDataTableRules.GetNOMBRE_ALMACENIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasNOMBRE_ALMACEN].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetNOMBRE_ALMACENIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasNOMBRE_ALMACEN].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetFECHA_RESERVAValue: DateTime;
begin
  result := DataTable.Fields[idx_DetalleReservasFECHA_RESERVA].AsDateTime;
end;

procedure TDetalleReservasDataTableRules.SetFECHA_RESERVAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_DetalleReservasFECHA_RESERVA].AsDateTime := aValue;
end;

function TDetalleReservasDataTableRules.GetFECHA_RESERVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasFECHA_RESERVA].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetFECHA_RESERVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasFECHA_RESERVA].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetCAUSA_RESERVAValue: String;
begin
  result := DataTable.Fields[idx_DetalleReservasCAUSA_RESERVA].AsString;
end;

procedure TDetalleReservasDataTableRules.SetCAUSA_RESERVAValue(const aValue: String);
begin
  DataTable.Fields[idx_DetalleReservasCAUSA_RESERVA].AsString := aValue;
end;

function TDetalleReservasDataTableRules.GetCAUSA_RESERVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasCAUSA_RESERVA].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetCAUSA_RESERVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasCAUSA_RESERVA].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_DetalleReservasID_ARTICULO].AsInteger;
end;

procedure TDetalleReservasDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DetalleReservasID_ARTICULO].AsInteger := aValue;
end;

function TDetalleReservasDataTableRules.GetID_ARTICULOIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasID_ARTICULO].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetID_ARTICULOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasID_ARTICULO].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_DetalleReservasREFERENCIA].AsString;
end;

procedure TDetalleReservasDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_DetalleReservasREFERENCIA].AsString := aValue;
end;

function TDetalleReservasDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasREFERENCIA].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasREFERENCIA].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_DetalleReservasDESCRIPCION].AsString;
end;

procedure TDetalleReservasDataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_DetalleReservasDESCRIPCION].AsString := aValue;
end;

function TDetalleReservasDataTableRules.GetDESCRIPCIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasDESCRIPCION].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetDESCRIPCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasDESCRIPCION].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetFAMILIAValue: String;
begin
  result := DataTable.Fields[idx_DetalleReservasFAMILIA].AsString;
end;

procedure TDetalleReservasDataTableRules.SetFAMILIAValue(const aValue: String);
begin
  DataTable.Fields[idx_DetalleReservasFAMILIA].AsString := aValue;
end;

function TDetalleReservasDataTableRules.GetFAMILIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasFAMILIA].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetFAMILIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasFAMILIA].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetUNIDAD_MEDIDAValue: String;
begin
  result := DataTable.Fields[idx_DetalleReservasUNIDAD_MEDIDA].AsString;
end;

procedure TDetalleReservasDataTableRules.SetUNIDAD_MEDIDAValue(const aValue: String);
begin
  DataTable.Fields[idx_DetalleReservasUNIDAD_MEDIDA].AsString := aValue;
end;

function TDetalleReservasDataTableRules.GetUNIDAD_MEDIDAIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasUNIDAD_MEDIDA].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetUNIDAD_MEDIDAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasUNIDAD_MEDIDA].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetFABRICANTEValue: String;
begin
  result := DataTable.Fields[idx_DetalleReservasFABRICANTE].AsString;
end;

procedure TDetalleReservasDataTableRules.SetFABRICANTEValue(const aValue: String);
begin
  DataTable.Fields[idx_DetalleReservasFABRICANTE].AsString := aValue;
end;

function TDetalleReservasDataTableRules.GetFABRICANTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasFABRICANTE].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetFABRICANTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasFABRICANTE].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetREFERENCIA_FABRValue: String;
begin
  result := DataTable.Fields[idx_DetalleReservasREFERENCIA_FABR].AsString;
end;

procedure TDetalleReservasDataTableRules.SetREFERENCIA_FABRValue(const aValue: String);
begin
  DataTable.Fields[idx_DetalleReservasREFERENCIA_FABR].AsString := aValue;
end;

function TDetalleReservasDataTableRules.GetREFERENCIA_FABRIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasREFERENCIA_FABR].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetREFERENCIA_FABRIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasREFERENCIA_FABR].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetCANTIDADValue: Currency;
begin
  result := DataTable.Fields[idx_DetalleReservasCANTIDAD].AsCurrency;
end;

procedure TDetalleReservasDataTableRules.SetCANTIDADValue(const aValue: Currency);
begin
  DataTable.Fields[idx_DetalleReservasCANTIDAD].AsCurrency := aValue;
end;

function TDetalleReservasDataTableRules.GetCANTIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasCANTIDAD].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetCANTIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasCANTIDAD].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetID_ALMACEN_RESERVAValue: Integer;
begin
  result := DataTable.Fields[idx_DetalleReservasID_ALMACEN_RESERVA].AsInteger;
end;

procedure TDetalleReservasDataTableRules.SetID_ALMACEN_RESERVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DetalleReservasID_ALMACEN_RESERVA].AsInteger := aValue;
end;

function TDetalleReservasDataTableRules.GetID_ALMACEN_RESERVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasID_ALMACEN_RESERVA].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetID_ALMACEN_RESERVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasID_ALMACEN_RESERVA].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetNOMBRE_ALMACEN_RESERVAValue: String;
begin
  result := DataTable.Fields[idx_DetalleReservasNOMBRE_ALMACEN_RESERVA].AsString;
end;

procedure TDetalleReservasDataTableRules.SetNOMBRE_ALMACEN_RESERVAValue(const aValue: String);
begin
  DataTable.Fields[idx_DetalleReservasNOMBRE_ALMACEN_RESERVA].AsString := aValue;
end;

function TDetalleReservasDataTableRules.GetNOMBRE_ALMACEN_RESERVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasNOMBRE_ALMACEN_RESERVA].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetNOMBRE_ALMACEN_RESERVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasNOMBRE_ALMACEN_RESERVA].AsVariant := Null;
end;

function TDetalleReservasDataTableRules.GetID_EMPRESA_ALMACEN_RESERVAValue: Integer;
begin
  result := DataTable.Fields[idx_DetalleReservasID_EMPRESA_ALMACEN_RESERVA].AsInteger;
end;

procedure TDetalleReservasDataTableRules.SetID_EMPRESA_ALMACEN_RESERVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DetalleReservasID_EMPRESA_ALMACEN_RESERVA].AsInteger := aValue;
end;

function TDetalleReservasDataTableRules.GetID_EMPRESA_ALMACEN_RESERVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_DetalleReservasID_EMPRESA_ALMACEN_RESERVA].IsNull;
end;

procedure TDetalleReservasDataTableRules.SetID_EMPRESA_ALMACEN_RESERVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_DetalleReservasID_EMPRESA_ALMACEN_RESERVA].AsVariant := Null;
end;


initialization
  RegisterDataTableRules(RID_Inventario, TInventarioDataTableRules);
  RegisterDataTableRules(RID_DetalleReservas, TDetalleReservasDataTableRules);

end.
